diff --git a/src/ui-status.c b/src/ui-status.c
new file mode 100644
index 0000000..d9aca37
--- /dev/null
+++ b/src/ui-status.c
@@ -0,0 +1,247 @@
+/* Copyright (C) 2020 Matt Henry <mcthenry+gnu@gmail.com>
+ *
+ * GNU Robots, ui-status.c
+ *
+ * GNU Robots is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * GNU Robots is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with GNU Robots.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "ui-status.h"
+#include "configs.h"
+#include "grobot.h"
+
+#include <glib.h>
+
+enum conn_signals
+{
+ ROBOT_UPDATE,
+ LAST_CONN_SIGNAL
+};
+
+enum status_headings
+{
+ TURN,
+ ACTION,
+ ENERGY,
+ SHIELDS,
+ SHOTS,
+ SCORE,
+ LAST_HEADING
+};
+
+static const gchar *status_heading[LAST_HEADING] =				\
+  {"Turn", "Action", "Energy", "Shields", "Shots", "Score"};
+
+struct _UIStatusPrivate
+{
+  GRobot   *robot;
+
+  gchar    *last_status;
+  gint      status_count;
+  GtkLabel *status_labels[LAST_HEADING];
+  gulong    connected_signals[LAST_CONN_SIGNAL];
+};
+
+G_DEFINE_TYPE(UIStatus, ui_status, GTK_TYPE_GRID)
+
+GtkWidget *ui_status_new()
+{
+  return GTK_WIDGET(g_object_new(UI_TYPE_STATUS, NULL));
+}
+
+static void
+ui_status_class_init (UIStatusClass *klass)
+{
+  // TODO: Do we need to chain to the parent?
+}
+
+static void
+ui_status_init(UIStatus *self)
+{
+  self->priv = g_malloc(sizeof(UIStatusPrivate));
+  self->priv->last_status = g_strdup("");
+  self->priv->status_count = 0;
+
+  gtk_grid_set_column_homogeneous(GTK_GRID(self), TRUE);
+
+  for(gint i = 0; i < 6; i++)
+    {
+      GtkWidget *lab = gtk_label_new(status_heading[i]);
+      gtk_grid_attach(GTK_GRID(self), GTK_WIDGET(lab), i, 0, 1, 1);
+      gtk_widget_show(lab);
+    }
+}
+
+static gchar*
+ui_status_num_delta_markup(glong before_num, glong after_num)
+{
+  gchar *retval;
+  if(before_num == after_num)
+    {
+      retval = g_strdup_printf("%ld", after_num);
+    }
+  else if (before_num < after_num)
+    {
+      retval = g_markup_printf_escaped ("%ld <span font-weight=\"bold\" foreground=\"blue\">+%ld</span>",
+			       after_num,
+			       after_num - before_num);
+    }
+  else
+    {
+      retval = g_markup_printf_escaped ("%ld <span font-weight=\"bold\" foreground=\"red\">%ld</span>",
+			       after_num,
+			       after_num - before_num);
+    }
+  return retval;
+}
+
+static void
+ui_status_update_status(UIStatus *self, GRobot_change *change)
+{
+  for(gint i = 0; i < LAST_HEADING; i++)
+    {
+      gchar *value = NULL;
+      switch(i)
+	{
+	case TURN:
+	  value = g_strdup_printf("%ld", change->after_change.turn);
+	  break;
+	case ACTION:
+	  if(strcmp(change->status_message, self->priv->last_status) == 0)
+	    self->priv->status_count++;
+	  else
+	    {
+	      g_free(self->priv->last_status);
+	      self->priv->status_count = 1;
+	      self->priv->last_status = g_strdup(change->status_message);
+	    }
+
+	  if(self->priv->status_count > 1)
+	    value = g_markup_printf_escaped("%s <span font-weight=\"bold\" foreground=\"blue\">x%d</span>",
+					    change->status_message,
+					    self->priv->status_count);
+	  else
+	    value = g_strdup(change->status_message);
+	  break;
+	case SHIELDS:
+	  value = ui_status_num_delta_markup(change->before_change.shields,
+					     change->after_change.shields);
+	  break;
+	case ENERGY:
+	  value = ui_status_num_delta_markup(change->before_change.energy,
+					     change->after_change.energy);
+	  break;
+	case SCORE:
+	  value = ui_status_num_delta_markup(change->before_change.score,
+					     change->after_change.score);
+	  break;
+	case SHOTS:
+	  value = ui_status_num_delta_markup(change->before_change.shots,
+					     change->after_change.shots);
+	  break;
+	default:
+	  if(NULL != self->priv->status_labels[i])
+	    g_warning("ui_status_update_status: don't know how to update %d", i);
+	}
+      if(NULL != value && NULL != self->priv->status_labels[i])
+	{
+	  gtk_label_set_markup(self->priv->status_labels[i], value);
+	}
+      g_free(value); // Free the memory since it was never used
+    }
+}
+
+static void
+ui_status_update_status_unmarshal(gpointer data_wrapper[])
+{
+  GRobot_change *change = data_wrapper[1];
+  ui_status_update_status(UI_STATUS(data_wrapper[0]), change);
+
+  g_free(change);
+  g_free(data_wrapper);
+}
+
+static void
+ui_status_on_stats_update(GRobot *robot, gpointer param, gpointer data)
+{
+  g_return_if_fail(IS_UI_STATUS(data));
+  /* TODO: this check currently won't work because G_IS_ROBOT isn't fully defined in grobot.h
+  g_return_if_fail(G_IS_ROBOT(robot)); */
+
+  gpointer* data_wrapper;
+  data_wrapper = g_malloc(sizeof(gpointer) * 2);
+  data_wrapper[0] = data;
+  data_wrapper[1] = g_memdup(param, sizeof(GRobot_change));
+
+  gdk_threads_add_idle(G_SOURCE_FUNC(ui_status_update_status_unmarshal), data_wrapper);
+}
+
+void
+ui_status_set_robot(UIStatus *self, GRobot *robot)
+{
+  g_return_if_fail(IS_UI_STATUS(self));
+  g_return_if_fail(G_IS_ROBOT(robot));
+
+  self->priv->robot = g_object_ref(robot);
+
+  for(gint i = 0; i < LAST_HEADING; i++)
+    {
+      gchar *value = NULL;
+      switch(i)
+	{
+	case TURN:
+	  value = g_strdup_printf("%ld", g_robot_get_turn(robot));
+	  break;
+	case ACTION:
+	  value = "Startup";
+	  break;
+	case SHIELDS:
+	  value = g_strdup_printf("%ld", g_robot_get_shields(robot));
+	  break;
+	case ENERGY:
+	  value = g_strdup_printf("%ld", g_robot_get_energy(robot));
+	  break;
+	case SCORE:
+	  value = g_strdup_printf("%ld", g_robot_get_score(robot));
+	  break;
+	case SHOTS:
+	  value = g_strdup_printf("%ld", g_robot_get_shots(robot));
+	  break;
+	  /* default: */
+	  /* Don't add in the default case. */
+	}
+      if(NULL != value)
+	{
+	  GtkLabel *lab = GTK_LABEL(gtk_label_new(value));
+	  gtk_label_set_use_markup(lab, TRUE);
+	  gtk_grid_attach(GTK_GRID(self), GTK_WIDGET(lab), i, 1, 1, 1);
+	  gtk_widget_show(GTK_WIDGET(lab));
+	  self->priv->status_labels[i] = lab; /* Hang on the labels so that status
+				     update can use them. */
+	}
+    }
+
+  self->priv->connected_signals[ROBOT_UPDATE] =
+    g_signal_connect(robot,
+		     "robot-stats-update",
+		     G_CALLBACK(ui_status_on_stats_update),
+		     self);
+}
+
+GRobot*
+ui_status_get_robot(UIStatus *self)
+{
+  g_return_val_if_fail(IS_UI_STATUS(self), NULL);
+
+  return(self->priv->robot);
+}
diff --git a/src/ui-window.c b/src/ui-window.c
index 8034138..dd976c9 100644
--- a/src/ui-window.c
+++ b/src/ui-window.c
@@ -17,80 +17,443 @@
  */
 
 #include "ui-window.h"
-#include "ui-window-private.h"
-
 #include "ui-cmdwin.h"
 #include "ui-arena.h"
+#include "ui-status.h"
 
-#include "main.h"
+#include "grobot.h"
 #include "map.h"
+#include "api.h"
+
+#include "config.h"
 #include "configs.h"
 
-#include <gtk/gtkmain.h>
+#include "xpm/robot.xpm"
+
+#include <gtk/gtk.h>
+
+struct _UIWindowPrivate {
+  GtkWidget *menubar;
+  GtkWidget *statustab;
+  GtkWidget *cmdwin;
+  GtkWidget *arena;
+
+  Map *map;
+  GRobot *robot;
+};
+
+enum ui_window_properties
+  {
+   UI_WINDOW_PROP_0,
+   UI_WINDOW_PROP_MAP,
+   UI_WINDOW_PROP_ROBOT,
+   UI_WINDOW_PROP_LAST
+  };
+
+G_DEFINE_TYPE_WITH_PRIVATE (UIWindow, ui_window, GTK_TYPE_APPLICATION_WINDOW)
+
+static void
+ui_window_dispose (GObject *self)
+{
+  g_action_map_remove_action(G_ACTION_MAP(self), "map-open");
+  g_action_map_remove_action(G_ACTION_MAP(self), "scheme-interrupt");
+
+  /* These should all get disposed when the window disposes, but we'll
+     clear the priv object anyway */
+
+  UI_WINDOW(self)->priv->menubar = NULL;
+  UI_WINDOW(self)->priv->statustab = NULL;
+  UI_WINDOW(self)->priv->cmdwin = NULL;
+  UI_WINDOW(self)->priv->arena = NULL;
+
+  G_OBJECT_CLASS (ui_window_parent_class)->dispose (self);
+}
+
+static void
+ui_window_finalize (GObject *self)
+{
+  GValue *value = NULL;
+
+  g_value_init_from_instance(value, G_OBJECT(NULL));
+  g_object_set_property(self, "map", value);
+  g_object_set_property(self, "robot", value);
+
+  G_OBJECT_CLASS (ui_window_parent_class)->finalize (self);
+}
+
+static void
+ui_window_set_property(GObject *self, guint prop_id, const GValue *value,
+		       GParamSpec *pspec)
+{
+  /* it's not null if we got it, but it might not be ours */
+  g_return_if_fail(UI_WINDOW_IS_UI_WINDOW(self));
+
+  UIWindow *win = UI_WINDOW(self);
+  GObject *obj;
 
-#define UI_WINDOW_GET_PRIVATE(obj) \
-    G_TYPE_INSTANCE_GET_PRIVATE(obj, UI_TYPE_WINDOW, UIWindowPrivate)
+  switch (prop_id)
+    {
+    case UI_WINDOW_PROP_MAP:
+      obj = g_value_get_object(value);
+      if(NULL != obj)
+	  g_assert(G_IS_MAP(obj));
+      if(NULL != win->priv->map)
+	g_object_unref(win->priv->map);
+      win->priv->map = g_object_ref(MAP(obj));
+      ui_arena_set_map(UI_ARENA(win->priv->arena), win->priv->map);
+      break;
+    case UI_WINDOW_PROP_ROBOT:
+      obj = g_value_get_object(value);
+      if(NULL != obj)
+	g_assert(G_IS_ROBOT(obj));
+      if(NULL != win->priv->robot)
+	g_object_unref(win->priv->robot);
+      win->priv->robot = g_object_ref(G_ROBOT(obj));
+      ui_status_set_robot(UI_STATUS(win->priv->statustab), win->priv->robot);
+      break;
+    default:
+      G_OBJECT_WARN_INVALID_PROPERTY_ID(self, prop_id, pspec);
+      break;
+    }
+}
+
+static void
+ui_window_get_property(GObject *self, guint prop_id, GValue *value,
+		       GParamSpec *pspec)
+{
+  /* it's not null if we got it, but it might not be ours */
+  g_return_if_fail(UI_WINDOW_IS_UI_WINDOW(self));
 
-G_DEFINE_TYPE(UIWindow, ui_window, GTK_TYPE_WINDOW)
+  UIWindow *win = UI_WINDOW(self);
 
-static void on_ui_window_destroy(GtkWidget *widget, gpointer data);
+  switch (prop_id)
+    {
+    case UI_WINDOW_PROP_MAP:
+      g_value_set_object(value, g_object_ref(G_OBJECT(win->priv->map)));
+      break;
+    case UI_WINDOW_PROP_ROBOT:
+      g_value_set_object(value, g_object_ref(G_OBJECT(win->priv->robot)));
+      break;
+    default:
+      G_OBJECT_WARN_INVALID_PROPERTY_ID(self, prop_id, pspec);
+      break;
+    }
+}
 
-GtkWidget *ui_window_new()
+static void
+ui_window_class_init (UIWindowClass *klass)
 {
-	return GTK_WIDGET(g_object_new(UI_TYPE_WINDOW, NULL));
+  GObjectClass *object_class = G_OBJECT_CLASS (klass);
+
+  object_class->dispose = ui_window_dispose;
+  object_class->finalize = ui_window_finalize;
+  object_class->set_property = ui_window_set_property;
+  object_class->get_property = ui_window_get_property;
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), UI_WINDOW_PROP_MAP,
+     g_param_spec_object("map",
+			 "GNU Robots Map",
+			 "Map to use for the robot's exploration.",
+			 G_TYPE_OBJECT,
+			 G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), UI_WINDOW_PROP_ROBOT,
+     g_param_spec_object("robot",
+			 "GNU Robots Robot",
+			 "Robot that will explore the map.",
+			 G_TYPE_OBJECT,
+			 G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+  /*    GtkWidgetClass *widget_class = GTK_WIDGET_CLASS (klass);
+	widget_class->window_state_event = gedit_window_window_state_event;
+	widget_class->configure_event = gedit_window_configure_event;
+	widget_class->key_press_event = gedit_window_key_press_event; */
 }
 
-static void on_ui_window_destroy(GtkWidget *widget, gpointer data)
+static void
+scheme_interrupt_activated (GSimpleAction  *action,
+			    GVariant       *parameter,
+			    gpointer        user_data)
+{
+  api_interrupt();
+}
+
+static void
+quit_activated (GSimpleAction  *action,
+		GVariant       *parameter,
+		gpointer        user_data)
+{
+  GtkApplication *app;
+
+  app = GTK_APPLICATION (user_data);
+
+  g_application_quit(G_APPLICATION(app));
+}
+
+static void
+on_ui_window_destroy(GtkWidget *widget, gpointer data)
 {
 	gtk_widget_hide(widget);
 	gtk_main_quit();
-	exit_nicely();
 }
 
-static void ui_window_init(UIWindow *window)
+
+static gchar*
+ui_window_choose_file(GtkWidget *parent, gchar *title, gint num_shortcuts, gchar **shortcuts)
 {
-	window->priv = UI_WINDOW_GET_PRIVATE(window);
+  GtkWidget* file_chooser =
+    gtk_file_chooser_dialog_new(title,
+				GTK_WINDOW(parent),
+				GTK_FILE_CHOOSER_ACTION_OPEN,
+				"Cancel", GTK_RESPONSE_CANCEL,
+				"Open", GTK_RESPONSE_ACCEPT,
+				NULL);
+
+  for(gint i = 0; i < num_shortcuts; i++)
+    {
+      if(NULL != shortcuts[i])
+	gtk_file_chooser_add_shortcut_folder(GTK_FILE_CHOOSER (file_chooser), shortcuts[i], NULL);
+    }
 
-	g_signal_connect(G_OBJECT(window), "destroy",
-		G_CALLBACK(on_ui_window_destroy), NULL);
+  char *filename = NULL;
+  if (gtk_dialog_run (GTK_DIALOG (file_chooser)) == GTK_RESPONSE_ACCEPT)
+    {
+      filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER (file_chooser));
+    }
+  gtk_widget_destroy(file_chooser);
+ 
+  return(filename);
+}
+
+static void
+map_open_activated (GSimpleAction  *action,
+		    GVariant       *parameter,
+		    gpointer        user_data)
+{
+  UIWindow *win = UI_WINDOW(user_data);
+  const gint num_shortcuts = 2;
+  gchar **shortcuts = g_malloc(num_shortcuts * sizeof(gchar**));
+  shortcuts[0] = getenv(MAPS_PATH_ENV);
+  shortcuts[1] = MAPS_PATH;
 
-	gtk_window_set_title(GTK_WINDOW(window), "GNU Robots");
-	gtk_window_set_resizable(GTK_WINDOW(window), FALSE);
+  gchar *map_filename = ui_window_choose_file(GTK_WIDGET(win), "Load Map File", num_shortcuts, shortcuts);
 
-	/* stdio is redirected in here...: */
-	window->priv->cmdwin = ui_cmdwin_new();
-	/* ^so that's needed before guile can start... */
+  g_free(shortcuts);
 
-	window->priv->arena = ui_arena_new();
+  if(NULL != map_filename)
+    {
+      Map *map = win->priv->map;
+      GRobot *robot = win->priv->robot;
+      GError *error = NULL;
+      map_load_filename(map, map_filename, &error);
+      if(NULL != error)
+	{
+	  GtkWidget *dialog =
+	    gtk_message_dialog_new (GTK_WINDOW(win),
+				    GTK_DIALOG_DESTROY_WITH_PARENT,
+				    GTK_MESSAGE_ERROR,
+				    GTK_BUTTONS_CLOSE,
+				    "Error loading file '%s': %s",
+				    map_filename, error->message);
+	  gtk_dialog_run (GTK_DIALOG (dialog));
+	  gtk_widget_destroy (dialog);
+	  //	  g_error("Unable to load map: %s", error->message);
+	  g_error_free(error);
+	}
+      else if(NULL != robot) {
+	map_auto_place_robot(map, robot);
+      }
+    }
 }
 
-void ui_window_postinit(UIWindow *window, Map* volatile* map)
+static void
+about_activated (GSimpleAction  *action,
+		 GVariant       *parameter,
+		 gpointer        user_data)
 {
-	GtkWidget *vbox;
+  const gchar *authors[] = {
+			    "Bradley Smith <brad@brad-smith.co.uk>",
+			    "Daniel M. B. Fortes Manoel <dmbfm2@uol.com.br>",
+			    "James Hall <jhall@freedos.org>",
+			    "Tim Northover <tim@pnorthover.freeserve.co.uk>",
+			    "Zeeshan Ali Khattak <zeenix@gmail.com>",
+			    "Eric P. Hutchins <hutchiep190@potsdam.edu>",
+			    NULL
+  };
 
-	vbox = gtk_vbox_new(FALSE, 2);
+  const gchar *documentors[] = {
+    NULL
+  };
 
-	while(!*map); /* wait for map object creation by guile thread */
+  const gchar *license =
+    "GNU Robots is free software: you can redistribute it and/or modify\n"
+    "it under the terms of the GNU General Public License as published by\n"
+    "the Free Software Foundation, either version 3 of the License, or\n"
+    "(at your option) any later version.\n"
+    "\nGNU Robots is distributed in the hope that it will be useful,\n"
+    "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
+    "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
+    "GNU General Public License for more details.\n"
+    "\nYou should have received a copy of the GNU General Public License\n"
+    "along with GNU Robots.  If not, see <http://www.gnu.org/licenses/>.\n";
 
-	/* ... because we need guile to load the map before we do this: */
-	ui_arena_set_map(UI_ARENA(window->priv->arena), *map);
+  GdkPixbuf *pixbuf, *transparent;
+  pixbuf = NULL;
+  transparent = NULL;
+  pixbuf = gdk_pixbuf_new_from_xpm_data ((const gchar**)robot_xpm);
+  transparent = gdk_pixbuf_add_alpha (pixbuf, TRUE, 0xff, 0xff, 0xff);
 
-	/* TODO: Add menu first etc */
-	gtk_box_pack_start(GTK_BOX(vbox), window->priv->arena, TRUE, TRUE, 0);
-	gtk_box_pack_start(GTK_BOX(vbox), window->priv->cmdwin, TRUE, TRUE, 0);
+  gtk_show_about_dialog (NULL,
+			 "program-name", PACKAGE_NAME,
+			 "version", PACKAGE_VERSION,
+			 "copyright", COPYRIGHT,
+			 "license", license,
+			 "website", PACKAGE_URL,
+			 "comments", "Program a robot to explore on its own.",
+			 "authors", authors,
+			 "documenters", documentors,
+			 "logo", transparent,
+                         "title", "About GTK+ Code Demos",
+			 NULL);
+
+  g_object_unref (transparent);
+}
+
+static GtkWidget*
+ui_window_menu(UIWindow *self)
+{
+  GActionEntry actions[] =
+    {{"map-open", map_open_activated, NULL, NULL, NULL},
+     {"scheme-interrupt", scheme_interrupt_activated, NULL, NULL, NULL}};
+
+  g_action_map_add_action_entries (G_ACTION_MAP (self),
+  				   actions,
+  				   G_N_ELEMENTS (actions),
+  				   self);
+
+  GMenu *gmenu = g_menu_new();
+
+  g_menu_append(gmenu, "_Open Map", "win.map-open");
+  g_menu_append(gmenu, "_Interrupt Scheme", "win.scheme-interrupt");
+
+  GtkWidget *mbar = gtk_header_bar_new();
+  gtk_header_bar_set_show_close_button(GTK_HEADER_BAR(mbar), TRUE);
+  gtk_header_bar_set_title(GTK_HEADER_BAR(mbar), PACKAGE_NAME);
+
+  GtkMenuButton *hamburger = GTK_MENU_BUTTON(gtk_menu_button_new());
+  gtk_menu_button_set_menu_model(hamburger, G_MENU_MODEL(gmenu));
+  gtk_menu_button_set_direction(hamburger, GTK_ARROW_NONE);
+
+  gtk_header_bar_pack_end(GTK_HEADER_BAR(mbar), GTK_WIDGET(hamburger));
+
+  gtk_widget_show_all(mbar);
+  return mbar;
+}
+
+static void
+ui_window_init(UIWindow *self)
+{
+  self->priv = ui_window_get_instance_private (self);
+
+  g_signal_connect(G_OBJECT(self), "destroy",
+		   G_CALLBACK(on_ui_window_destroy), NULL);
+
+  gtk_window_set_title(GTK_WINDOW(self), "GNU Robots");
+
+  self->priv->menubar = ui_window_menu(self);
+  /* stdio is redirected in here...: */
+  self->priv->cmdwin = ui_cmdwin_new();
+  /* ^so that's needed before guile can start... */
+
+  self->priv->arena = ui_arena_new(NULL);
+  self->priv->statustab = ui_status_new();
+
+  gtk_window_set_titlebar(GTK_WINDOW(self), self->priv->menubar);
+  GtkWidget *vbox;
+
+  vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 2);
+
+  gtk_box_pack_start(GTK_BOX(vbox), self->priv->arena, TRUE, TRUE, 0);
+  gtk_box_pack_start(GTK_BOX(vbox), self->priv->statustab, TRUE, TRUE, 0);
+  gtk_box_pack_start(GTK_BOX(vbox), self->priv->cmdwin, TRUE, TRUE, 0);
+
+  gtk_container_add(GTK_CONTAINER(self), vbox);
+
+  gtk_widget_show_all(vbox);
+  gtk_widget_show_all(GTK_WIDGET(self));
+}
+
+GtkWidget *
+ui_window_new(Map *map, GRobot *robot)
+{
+  g_return_val_if_fail(G_IS_MAP(map), NULL);
+  g_return_val_if_fail(G_IS_ROBOT(robot), NULL);
+
+  return g_object_new(UI_WINDOW_TYPE,
+		      "map", map, "robot", robot,
+		      NULL);
+}
+
+static void
+startup(GtkApplication* app,
+	gpointer        user_data[])
+{
+  GActionEntry actions[] =
+    {{"about", about_activated, NULL, NULL, NULL},
+     {"quit", quit_activated, NULL, NULL, NULL}};
+
+  g_action_map_add_action_entries (G_ACTION_MAP (app),
+  				   actions,
+  				   G_N_ELEMENTS (actions),
+  				   app);
+
+  GMenu *gmenu = g_menu_new();
+
+  g_menu_append(gmenu, "_About", "app.about");
+  g_menu_append(gmenu, "_Quit", "app.quit");
+
+  gtk_application_set_app_menu(app, G_MENU_MODEL(gmenu));
+
+  gtk_application_set_accels_for_action
+    (app, "app.quit", (const gchar*[]) {"<Ctrl>Q", NULL});
+  gtk_application_set_accels_for_action
+    (app, "win.map-open", (const gchar*[]) {"<Ctrl>O", NULL});
+  gtk_application_set_accels_for_action
+    (app, "win.scheme-interrupt", (const gchar*[]) {"<Ctrl>C", NULL});
+}
+
+static void
+activate(GtkApplication* app,
+	 gpointer        user_data[])
+{
+  GtkWidget *window;
+
+  window = ui_window_new(MAP(user_data[0]), G_ROBOT(user_data[1]));
+  gtk_application_add_window(app, GTK_WINDOW(window));
+
+  gtk_widget_show_all (window);
+}
+
+gint
+ui_window_main(Map *map, GRobot *robot, gint argc, gchar **argv)
+{
+  g_return_val_if_fail(G_IS_MAP(map), EXIT_FAILURE);
+  g_return_val_if_fail(G_IS_ROBOT(robot), EXIT_FAILURE);
 
-	gtk_container_add(GTK_CONTAINER(window), vbox);
+  gpointer user_data[2] = {map, robot};
 
-	gtk_widget_show(window->priv->cmdwin);
-	gtk_widget_show(window->priv->arena);
-	gtk_widget_show(vbox);
-	gtk_widget_show(GTK_WIDGET(window));
+  GtkApplication *app = gtk_application_new("org.gnu.gnurobots",
+					    G_APPLICATION_FLAGS_NONE);
+  g_signal_connect(app, "startup", G_CALLBACK(startup), user_data);
+  g_signal_connect(app, "activate", G_CALLBACK(activate), user_data);
+  gint status = g_application_run(G_APPLICATION(app), argc, argv);
+  g_object_unref(app);
 
-	ui_arena_postinit(UI_ARENA(window->priv->arena));
+  return status;
 }
 
-static void ui_window_class_init(UIWindowClass *klass)
+GOptionGroup*
+ui_window_gtk_option_group()
 {
-	g_type_class_add_private(G_OBJECT_CLASS(klass),
-		sizeof(UIWindowPrivate));
+  return gtk_get_option_group(TRUE);
 }
